/*

Copyright (C) 2000 - 2003 Christian Kreibich <christian@whoop.org>.

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to
deal in the Software without restriction, including without limitation the
rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
sell copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies of the Software and its documentation and acknowledgment shall be
given in the documentation and software packages that this Software was
used.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

*/
#ifndef __nd_packet_iterator_h
#define __nd_packet_iterator_h

#include <gtk/gtk.h>

#include <nd.h>
#include <nd_packet.h>

/**
 * nd_pit_init - packet iterator initializer
 * @pit: iterator to initialize.
 * @trace: trace whose packets are to be iterated.
 *
 * Returns: %TRUE when iterator initialization was
 * successful, %FALSE otherwise.
 */
gboolean           nd_pit_init(LND_PacketIterator *pit,
			       LND_Trace *trace);

/* FIXME fix comment
 *
 * Returns: %TRUE when iterator initialization was
 * successful, %FALSE otherwise.
 */
gboolean           nd_pit_init_mode(LND_PacketIterator *pit,
				    LND_Trace *trace,
				    LND_PacketIteratorMode mode);

/**
 * nd_pit_get - accessor function.
 * @pit: iterator to retrieve current packet from.
 *
 * Accessor function, returns the packet the iterator currently
 * points to.
 *
 * Returns: currently iterated packet.
 */
LND_Packet        *nd_pit_get(LND_PacketIterator *pit);


/**
 * nd_pit_next - advances the iterator.
 * @pit: iterator to advance
 *
 * This function advances the iterator, and returns that packet. If there are
 * no more packets, %NULL is returned. Upon advancing the iterator,
 * the progressbar and the packet's tcpdump line automatically
 * get updated.
 *
 * Returns: next packet.
 */
LND_Packet        *nd_pit_next(LND_PacketIterator *pit);


#define nd_pit_get_index   libnd_pit_get_index
#define nd_pit_is_current  libnd_pit_is_current

#endif
